/*****************************************************************************

        GRAOUMF TRACKER 2
        Author: Laurent de Soras, 1996-2016

--- Legal stuff ---

This program is free software. It comes without any warranty, to
the extent permitted by applicable law. You can redistribute it
and/or modify it under the terms of the Do What The Fuck You Want
To Public License, Version 2, as published by Sam Hocevar. See
http://sam.zoy.org/wtfpl/COPYING for more details.

*****************************************************************************/



#if defined (ARCHI_CURRENT_HEADER)
	#error Inclusion recursive du header ARCHI.
#endif
#define	ARCHI_CURRENT_HEADER

#if ! defined (ARCHI_HEADER_INCLUDED)
#define	ARCHI_HEADER_INCLUDED

/*\\\ INLCUDE \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

#include <climits>
#include <cstdint>



/*\\\ CONSTANTES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



// 0 = big endian, 1 = little endian
#define	OS_BYTE_ORDER		1



/*\\\ TYPES & STRUCTURES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

/* 8 bits */
typedef	uint8_t			BYTE;
typedef	uint8_t			UBYTE;
typedef	int8_t			SBYTE;

/* 16 bits */
typedef	uint16_t			WORD;
typedef	uint16_t			UWORD;
typedef	int16_t			SWORD;

/* 32 bits */
typedef	int32_t			LWORD;
typedef	uint32_t			ULWORD;
typedef	int32_t			SLWORD;

/* 64 bits */
typedef	int64_t			QWORD;
typedef	uint64_t			UQWORD;
typedef	int64_t			SQWORD;



/*\\\ FIN DU FICHIER \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

#endif

#undef ARCHI_CURRENT_HEADER
